//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DimGray
#property indicator_color3  PaleVioletRed
#property indicator_color4  DeepSkyBlue
#property indicator_width4  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT

//
//
//
//
//

extern int    DpoPeriod     = 14;
extern int    DpoPrice      = PRICE_CLOSE;
extern int    MaPeriod      = 14;
extern int    AtrPeriod     = 14;
extern double AtrMultiplier =  2;

//
//
//
//
//

double dpo[];
double atrUp[];
double atrDn[];
double ma[];

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,atrUp);
   SetIndexBuffer(1,ma);
   SetIndexBuffer(2,atrDn);
   SetIndexBuffer(3,dpo);
   return(0);
}

//
//
//
//
//

int start()
  {
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   int shift = DpoPeriod/2+1;
      for(i=limit; i>=0; i--) dpo[i]   = iMA(NULL,0,1,0,MODE_SMA,DpoPrice,i)-iMA(NULL,0,DpoPeriod,0,MODE_SMA,DpoPrice,i+shift);
      for(i=limit; i>=0; i--) 
      { 
         double atr = iATR(NULL,0,AtrPeriod,i);
            ma[i]    = iMAOnArray(dpo,0,MaPeriod,0,MODE_SMA,i);
            atrUp[i] = ma[i]+atr*AtrMultiplier;
            atrDn[i] = ma[i]-atr*AtrMultiplier;
      }
   return(0);
}